import { ApolloLink, Observable, Operation, NextLink, FetchResult } from '@apollo/client/core';
export { OperationQueuing, QueuedRequest } from './queuing';
export type FetchAccessToken = (...args: any[]) => Promise<Response>;
export type HandleFetch<AccessTokenPayloadType> = (accessTokenPayload: AccessTokenPayloadType, operation: Operation) => void;
export type HandleResponse = (operation: Operation, accessTokenField: string) => any;
export type HandleError = (err: Error, operation: Operation) => void;
export type IsTokenValidOrUndefined = (operation: Operation, ...args: any[]) => Promise<boolean>;
export declare namespace TokenRefreshLink {
    interface Options<AccessTokenPayloadType> {
        accessTokenField?: string;
        isTokenValidOrUndefined: IsTokenValidOrUndefined;
        handleFetch: HandleFetch<AccessTokenPayloadType>;
        fetchAccessToken: FetchAccessToken;
        handleResponse?: HandleResponse;
        handleError?: HandleError;
    }
}
export declare class TokenRefreshLink<AccessTokenPayloadType = string> extends ApolloLink {
    private accessTokenField;
    private isTokenValidOrUndefined;
    private fetchAccessToken;
    private handleFetch;
    private handleResponse;
    private handleError;
    private fetching;
    private queue;
    constructor(params: TokenRefreshLink.Options<AccessTokenPayloadType>);
    request(operation: Operation, forward: NextLink): Observable<FetchResult> | null;
    private extractToken;
}
//# sourceMappingURL=tokenRefreshLink.d.ts.map